/*
*	FILE:		animate.h
*	AUTHOR:		R. Gonzalez
*	CREATED:	November 8, 1990
*
*	Defines animated nested segment.
*/

# ifndef	animate_h
# define	animate_h

# include	"segment.h"

/******************************************************************
*   Nested segment which may be animated.
******************************************************************/
struct	Animated_Segment:Nested_Segment
{
	Transformation		*animation[MAX_SEGMENTS];

/* In C++ the following two instance variables would be 'private'
*	rather than simply 'protected'.  That is, derived classes 
*	should NOT assign to them.  They are assigned only via the
*	log_animated_segment() method.
*/
	Animated_Segment	*animated_segment_ptr[MAX_SEGMENTS];
	int					num_animated_segments;
	
	boolean			init(void);
	virtual void	log_animated_segment(Segment*);
	virtual void	animate(void);
	boolean			destroy(void);
};

# endif