/*
*	FILE:		coord.h
*	AUTHOR:		R. Gonzalez
*	CREATED:	October 2, 1990
*
*	Defines 2D and 3D coordinate classes for the picture
*	application.
*/

# ifndef	coord_h
# define	coord_h

# include	"class.h"
# include	"frame.h"
# include	"trans.h"

/******************************************************************
*   2D coordinate
******************************************************************/
struct	Coord2:Generic_Class
{

	double			x;	/* public */
	double			y;	/* public */
	
	boolean			init(void);
	virtual void	set(double,double);
	virtual void	convert(Coord2*,Frame*,Frame*);
};

/******************************************************************
*   3D coordinate
******************************************************************/
struct	Coord3:Generic_Class
{
	double			x;	/* public */
	double			y;	/* public */
	double			z;	/* public */
	
	boolean			init(void);
	virtual void	set(double,double,double);
	virtual void	apply(Coord3*,Transformation*);
	virtual void	equate(Coord3*);
};

# endif