/*
*	FILE:		line.h
*	AUTHOR:		R. Gonzalez
*	CREATED:	October 6, 1990
*
*	Defines 3D line segment for picture application.
*/

# ifndef	line_h
# define	line_h

# include	"segment.h"
# include	"trans.h"
# include	"camera.h"
# include	"project.h"
# include	"coord.h"

/******************************************************************
*   3D line
******************************************************************/
struct	Line:Segment
{
	Coord3			*c1;
	Coord3			*c2;
	color			line_color;
	
	boolean			init(void);
	virtual void	set_coord(double,double,double,double,double,double);
	void			set_color(color);
	void			draw(Camera*,Projector*,Transformation*);
	void			move(Transformation*);
	boolean			destroy(void);
};

# endif